Subject: Re: [aqm] An independent implementation of CoDel in FreeBSD/ipfw/dummynet

From: Jana Iyengar <[email-masked]>
Date: Fri, 12 Feb 2016 16:53:33 -0800

Thanks much, Rasool, Grenville! And apologies for the late response. More
inline.

On Wed, Dec 16, 2015 at 3:35 AM, Rasool Al-Saadi <[email-masked]>
wrote:

> Hello all,
>
> I am Rasool Al-Saadi, a PhD student at Centre for Advanced Internet
> Architectures - Swinburne University of Technology. I and my supervisor
> Grenville Armitage are implementing CoDel (and eventually PIE, FQ_CoDel and
> FQ_PIE) in FreeBSD targeting ipfw/dummynet framework as a small project
> funded by Comcast Corporation, USA.
>
> We used CoDel I-D (https://datatracker.ietf.org/doc/draft-ietf-aqm-codel/)
> as the main source to implement CoDel and we believe that the information
> in the latest draft (draft-ietf-aqm-codel-02) sufficient and the
> pseudo-code is straightforward to create functional CoDel code. However, we
> have some questions/confusion regarding CoDel I-D:
>
> 1- There is little confusion in the text. In section 3.3, the text says
> "... the initial drop spacing SHOULD be set to the estimator's interval
> plus twice the target (i.e., initial drop spacing = 1.1 * interval) ...",
> while in section 4.1, the text says "As discussed in section 3.3, the
> initial next drop spacing is intended to be long enough to give the
> endpoints time to react to the single drop so SHOULD be set to a value of
> 1.0 to 1.1 times the interval."
>

I've changed the second occurrence to say "1.1 times the interval", to
avoid ambiguity.

> 2- In section 3.2 and 4.4, the text says the ideal setpoint is 5-10% of
> the interval (connection RTT). So, should we allow the user to specify the
> target value as a percentage of the interval or an absolute value?
>

While this is descriptive text, the recommendation in the draft is to use
5ms for Internet traffic. There's normative text in the same section that
says "Thus target SHOULD be set to 5ms for normal Internet traffic." I'm
leaving this text as is, unless you have a specific suggestion -- happy to
take it!

Thanks again for your careful read, and for your implementation work!
- jana

> Regards,
> Rasool
>
> _______________________________________________
> aqm mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/aqm
>